<?php
namespace PME\Controllers\Parametrizacao;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class ValRefReportController extends \Zeedhi\Framework\Controller\Report {

  protected $birtStrategy;
  protected $utilities;

  public function __construct(ReportService $reportService, $birtStrategy, $utilities) {
    $this->birtStrategy  = $birtStrategy;
    $this->utilities   = $utilities;

    parent::__construct($reportService);
  }

	protected $reportMapping = array (
    'PME02501' => 
      array (
          'strategy' => 'BIRT',
          'parameterMapping' => 
          array (
            "CENTRAL" => "P_CDFILCENTPME",
            "TIPOCARD"  => "P_CDTIPOCARD",
            "NRORG"   => "P_NRORG"
          )
      )
    );
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
      $row = $request->getRow();
      $nrorg = $this->utilities->getNrOrg();
      
      if (empty($row['TIPOCARD'])) $row['TIPOCARD'] = 'T';
      else {
         $cardConcat = '_';
         foreach($row['TIPOCARD'] as $card){
          $cardConcat .= $card.'_';
         }
        $row['TIPOCARD'] = $cardConcat;
      }
      
      $row['NRORG'] = $nrorg;
      $this->birtStrategy->setReportLocale($this->utilities->getLanguage());
      $this->birtStrategy->setReportFormat(strtolower($row['reportFormat']));
    }
}